#!/usr/bin/env ruby
require './lexer'
require './translate'

def tosses(c)
  if c <= 129
    "#{sprintf("%3d", 129 - c)} from 129"
  else
    "#{sprintf("%3d", 255 - c)} from 255"
  end
end

if ARGV.length < 1
  puts "Usage: #{$0} file"
  exit(1)
end

lines = if ARGV[0] != '-'
          IO.readlines(ARGV[0]).join('')
        else
          STDIN.read
        end
opcodes = translate(lex(lines)).bytes.map {|c| c.ord}

pokemon_names = IO.readlines('pokemon.txt').map {|v| v.strip}
item_names = IO.readlines('items.txt').map {|v| v.strip}

i = 0
items = []
item = []
longest = 0
opcodes.each do |c|
  if i.even?
    item << item_names[c]
    len = item_names[c].length
    longest = len if longest < len
  else
    item << "x#{sprintf("%3d", c)} [#{tosses(c)}]"

    items << item
    item = []
  end
  i += 1
end

if !item.empty?
  items << [item[0], '[any]']
end

puts opcodes.map {|c| sprintf("%02X", c.ord)}.join(' ')

msg = items.reduce('') {|msg,item| msg += sprintf("%-#{longest}s %s\n", item[0], item[1])}

puts "#{msg}"

exit

pokemon = opcodes.map {|c| pokemon_names[c]}

puts pokemon.join("\n")

